package it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.demo1;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;

public class DemoClick {
	/* la finestra principale */
	private final JFrame frame;
	/* un bottone */
	private final JButton button;

    public DemoClick() {
    		this.frame = new JFrame("Demo");
    		this.button = new JButton("   Click me!   ");
        /* crea l'handler */
    		ActionListener handler = 
    				new ButtonClickHandler(this.button);
    		/* aggiunge il listener al bottone */
    		this.button.addActionListener(handler);
    		/* aggiungo il bottone al panel del frame */
        this.frame.getContentPane().add(button);
        
        this.frame.pack();
        this.frame.setVisible(true);
    }
    
    public static void main(String[] args){
        new DemoClick();
    }
}

/* uso una classe specifica che implementa 
 * l'interfaccia ActionListener e che 
 * incapsula il codice da eseguire quando si 
 * verifica il click sul bottone.
 * Tale codice e' il codice del metodo 
 * actionPerformed(ActionEvent)
 */
class ButtonClickHandler implements ActionListener {    	
    private final JButton button;
	
    public ButtonClickHandler(JButton button) {
    		if (button == null) throw new IllegalArgumentException();
    		this.button = button;
	}
	/* codice da eseguire quando si verifica
    * un evento sul bottone
    */
    public void actionPerformed(ActionEvent e) {
    	  button.setText("You clicked me!");
    }
}

